/***************************************************************************
 *   $Id: simpleLog.h,v 1.2 2010/03/05 13:15:26 fabio Exp $
 *                                                                         *
 *   Copyright (C) 2009 by Fabio Asnicar  fabio.asnicar@elettra.trieste.it *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SIMPLELOG_H
#define SIMPLELOG_H

#include <QtDebug>
#include <tutil.h>
#include <tlog.h>

class simpleLog {

public:
    static void warn(string orig, string desc, string reas = "") {
        qDebug() << "WARNING - " << orig.c_str() << "\n" << desc.c_str() << "\n" << reas.c_str();
        log(Tango::WARN, orig, desc, reas);
    }
    static void error(string orig, string desc, string reas = "") {
        qDebug() << "ERROR   - " << orig.c_str() << "\n" << desc.c_str() << "\n" << reas.c_str();
        log(Tango::ERR, orig, desc, reas);
    }
    static void panic(string orig, string desc, string reas = "") {
        qDebug() << "PANIC   - " << orig.c_str() << "\n" << desc.c_str() << "\n" << reas.c_str();
        log(Tango::PANIC, orig, desc, reas);
    }
    static void error(string orig, DevErrorList err) {
        TLog log(err);
        qDebug() << "ERROR - " << orig.c_str() << "\n" << log.formatMessage();
        TUtil::instance()->addLog(log);
    }

protected:
    static void log(Tango::ErrSeverity sev, string orig, string desc, string reas) {
        Tango::DevErrorList errors(1);
        errors.length(1);
        errors[0].desc = desc.c_str();
        errors[0].severity = sev;
        errors[0].reason = reas.c_str();
        errors[0].origin = orig.c_str();
        TLog log(errors);
        TUtil::instance()->addLog(log);
    }
};

#endif

